searchNodes=[{"doc":"SFU engine implementation. One SFU instance is responsible for managing one room in which all tracks of one peer are forwarded to all other peers. The SFU engine works by sending and receiving messages. All messages are described below. To receive SFU messages you have to register your process so that SFU will know where to send its messages. Registering for messages Registration can be done by sending the message {register, pid} to the SFU instance, e.g. send ( sfu_pid , { :register , self ( ) } ) This will register your process to receive SFU messages. If your process implements GenServer behaviour then all messages will be handled by GenServer.handle_info/2 , e.g. @impl true def handle_info ( { _sfu_engine , { :sfu_media_event , :broadcast , event } } , state ) do for { _peer_id , pid } &lt;- state . peer_channels , do : send ( pid , { :media_event , event } ) { :noreply , state } end You can register multiple processes to receive messages from an SFU instance. In such a case each message will be sent to each registered process. Media Events The SFU engine needs to communicate with Membrane client libraries. This communication is done via Media Event messages. Media Events are blackbox messages that carry data important for the SFU engine and client libraries, but not for the user. Example Media Events are SDP offers, ICE candidates, and information about new peers. An application is obligated to transport Media Events from an SFU instance to its client library, and vice versa. When an SFU needs to send a message to a specific client, registered processes will receive {:sfu_media_event, to, event} , where to specifies the message destination. This can be either :broadcast , when the event should be sent to all peers, or peer_id when the messages should be sent to specified peer. The event is encoded in binary format, so it is ready to send without modification. Feeding an SFU instance with Media Events from a client library can be done by sending the message {:media_event, from, event} . Assuming the user process is a GenServer, the Media Event can be received by GenServer.handle_info/2 and conveyed to the SFU engine in the following way: @impl true def handle_info ( { :media_event , _from , _event } = msg , state ) do send ( state . sfu_engine , msg ) { :noreply , state } end What is important, Membrane SFU doesn't impose usage of any specific transport layer. You can e.g. use Phoenix and its channels. This can look like this: @impl true def handle_in ( &quot;mediaEvent&quot; , %{ &quot;data&quot; =&gt; event } , socket ) do send ( socket . assigns . room , { :media_event , socket . assigns . peer_id , event } ) { :noreply , socket } end Messages Each message the SFU sends is a two-element tuple {sfu_pid, msg} where sfu_pid is the pid of the SFU instance that sent message, and msg can be any data. Notice that thanks to presence of sfu_pid you can create multiple SFU instances. Example SFU message: { _sfu_pid , { :vad_notification , val , peer_id } } SFU sends following messages {:sfu_media_event, to, event} - a Media Event that should be transported to the client library. When from is :broadcast , the Media Event should be sent to all peers. When from is a peer_id , the Media Event should be sent to that specified peer. {:vad_notification, val, peer_id} - sent when peer with id peer_id is speaking. VAD stands for Voice Activity Detection . When val is true marks start of speech whereas false marks end of speech. {:new_peer, peer_id, metadata, track_metadata} - sent when a new peer tries to join to an SFU instance. metadata is any data passed by the client library while joining. track_metadata is a map where key is track id and value is its metadata defined in client library while adding a new track. {:peer_left, peer_id} - sent when the peer with peer_id leaves an SFU instance SFU receives following messages {:register, pid} - register given pid for receiving SFU messages {:unregister, pid} - unregister given pid from receiving SFU messages {:media_event, from, event} - feed Media Event to SFU. from is id of peer that this Media event comes from. {:accept_new_peer, peer_id} - accepts peer with id peer_id {:deny_new_peer, peer_id} - denies peer with id peer_id {:remove_peer, peer_id} - removes peer with id peer_id Peer id Peer ids must be assigned by application code. This is not done by the SFU engine or its client library. Ids can be assigned when a peer initializes its signaling channel. Assuming we use a Phoenix channel as signaling layer: def join ( &quot;room:&quot; &lt;&gt; room_id , _params , socket ) do # ... peer_id = UUID . uuid4 ( ) { :ok , assign ( socket , %{ room_id : room_id , room : room , peer_id : peer_id } ) } end","ref":"Membrane.RTC.Engine.html","title":"Membrane.RTC.Engine","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.html#get_registry_name/0","title":"Membrane.RTC.Engine.get_registry_name/0","type":"function"},{"doc":"Changes playback state of pipeline to :playing .","ref":"Membrane.RTC.Engine.html#play/1","title":"Membrane.RTC.Engine.play/1","type":"function"},{"doc":"Changes playback state to :prepared .","ref":"Membrane.RTC.Engine.html#prepare/1","title":"Membrane.RTC.Engine.prepare/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.html#start/2","title":"Membrane.RTC.Engine.start/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.html#start_link/2","title":"Membrane.RTC.Engine.start_link/2","type":"function"},{"doc":"Changes playback state to :stopped .","ref":"Membrane.RTC.Engine.html#stop/1","title":"Membrane.RTC.Engine.stop/1","type":"function"},{"doc":"Changes pipeline's playback state to :stopped and terminates its process.","ref":"Membrane.RTC.Engine.html#stop_and_terminate/2","title":"Membrane.RTC.Engine.stop_and_terminate/2","type":"function"},{"doc":"List of RTP extensions to use. At this moment only vad extension is supported. Enabling it will cause SFU sending {:vad_notification, val, endpoint_id} messages.","ref":"Membrane.RTC.Engine.html#t:extension_options_t/0","title":"Membrane.RTC.Engine.extension_options_t/0","type":"type"},{"doc":"SFU network configuration options. dtls_pkey and dtls_cert can be used e.g. when there are a lot of SFU instances and all of them need to use the same certificate and key. Example configuration can look like this: network_options : [ stun_servers : [ %{ server_addr : &quot;stun.l.google.com&quot; , server_port : 19_302 } ] ]","ref":"Membrane.RTC.Engine.html#t:network_options_t/0","title":"Membrane.RTC.Engine.network_options_t/0","type":"type"},{"doc":"SFU configuration options. id is used by logger. If not provided it will be generated.","ref":"Membrane.RTC.Engine.html#t:options_t/0","title":"Membrane.RTC.Engine.options_t/0","type":"type"},{"doc":"A map pointing from encoding names to lists of packet filters that should be used for given encodings. A sample usage would be to add silence discarder to OPUS tracks when VAD extension is enabled. It can greatly reduce CPU usage in rooms when there are a lot of people but only a few of them are actively speaking.","ref":"Membrane.RTC.Engine.html#t:packet_filters_t/0","title":"Membrane.RTC.Engine.packet_filters_t/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.html#t:stun_server_t/0","title":"Membrane.RTC.Engine.stun_server_t/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.html#t:turn_server_t/0","title":"Membrane.RTC.Engine.turn_server_t/0","type":"type"},{"doc":"Membrane RTC Engine Client and server libraries for Membrane RTC Engine.","ref":"readme.html","title":"Membrane RTC Engine","type":"extras"},{"doc":"Documentation of client library is available at https://hexdocs.pm/membrane_rtc_engine/js Documentation of server library is available at https://hexdocs.pm/membrane_rtc_engine","ref":"readme.html#documentation","title":"Membrane RTC Engine - Documentation","type":"extras"},{"doc":"The package can be installed by adding membrane_rtc_engine to your list of dependencies in mix.exs : def deps do [ { :membrane_rtc_engine , &quot;~&gt; 0.1.0-alpha.2&quot; } ] end","ref":"readme.html#installation","title":"Membrane RTC Engine - Installation","type":"extras"},{"doc":"For usage examples, please refer to our membrane_demo repository.","ref":"readme.html#usage","title":"Membrane RTC Engine - Usage","type":"extras"},{"doc":"To make the development a little easier, we augmented mix compile and mix docs tasks so that mix compile also installs npm dependencies and compiles TypeScript code and mix docs also generates documentation for TypeScript code. Thanks to this, there is no need to include compiled JS code in priv/static . It will be generated each time mix compile is called. TypeScript documentation will be generated under doc/js/ .","ref":"readme.html#developing","title":"Membrane RTC Engine - Developing","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane RTC Engine - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2021 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]